## mingw-w64-scc-3.6.0-1.src.tar.zst

=== examples/language/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)
project(test_project) # project name

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
if (${CMAKE_CXX_COMPILER_ID} MATCHES "Clang" OR ${CMAKE_CXX_COMPILER_ID} MATCHES "GNU" #[[GCC]])
    add_compile_options(-Wall -Wextra)
endif()

#[[
Set special flags when we are using clang toolchain
]]
if(${CMAKE_CXX_COMPILER_ID} STREQUAL Clang)
    if(${CMAKE_CXX_COMPILER_VERSION} VERSION_GREATER "15.0.0" )
        add_compile_definitions(HAS_CLANG_SOURCE_LOCATION)
    endif()
endif()

include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
add_executable(test_project main.cpp helper.cpp)

include(CheckIPOSupported)
check_ipo_supported(RESULT ipo_supported OUTPUT output)
if(ipo_supported)
    set_property(TARGET test_project PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
else()
    message(WARNING "IPO is not supported: ${output}")
endif()

=== vendor/github.com/boyter/gocodewalker/Makefile ===
# Some people have gotestsum installed and like it so use it if it exists
HAS_GOTESTSUM := $(shell which gotestsum)
ifdef HAS_GOTESTSUM
    TEST_CMD = gotestsum --format testname --packages="./..." -- -count=1 -tags=integration -v -p 1
else
    TEST_CMD = go test ./... --count=1 -tags=integration
endif

lint:
	@golangci-lint run --fix
	@golangci-lint run

test:
	@$(TEST_CMD)

test-run:
	@$(TEST_CMD) -run=$(RUN)

fuzz:
	go test -fuzz=FuzzTestGitIgnore -fuzztime 30s

test-coverage:
	go test ./... -coverprofile coverage.out && go tool cover -html=coverage.out -o coverage.html

mod:
	@go mod tidy
	@go mod vendor

clean:
	go clean -modcache

all: mod lint test fuzz

=== PKGBUILD ===
# Maintainer: Wu Zhenyu <wuzy01@qq.com>

_realname=scc
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=3.6.0
pkgrel=1
pkgdesc='Sloc, Cloc and Code: a very fast accurate code counter with complexity calculations and COCOMO estimates written in pure Go (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/boyter/scc"
msys2_references=(
  'aur: scc'
  'purl: pkg:golang/github.com/boyter/scc/v3'
)
license=('spdx:MIT OR Unlicense')
makedepends=(
  "$MINGW_PACKAGE_PREFIX-go"
  "$MINGW_PACKAGE_PREFIX-gcc"
)
options=('!strip')
source=("https://github.com/boyter/scc/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
noextract=("${_realname}-${pkgver}.tar.gz")
sha256sums=('15e09f446ee44f3ebdb59f55933128256588d0343988692f1064b9bfb4f96dd7')

prepare() {
  tar -xf "${_realname}-${pkgver}.tar.gz" || true
  cd "$_realname-$pkgver"
  mkdir -p build/
}

build() {
  cd "$_realname-$pkgver"
  export CGO_CPPFLAGS="${CPPFLAGS}"
  export CGO_CFLAGS="${CFLAGS}"
  export CGO_CXXFLAGS="${CXXFLAGS}"
  export CGO_LDFLAGS="${LDFLAGS}"
  export GOFLAGS="-trimpath -ldflags=-linkmode=external -mod=readonly -modcacherw"
  case "${CARCH}" in
    i686|x86_64)
      GOFLAGS+=" -buildmode=pie"
      ;;
  esac

  go build -o build ./...
}

check() {
  cd "$_realname-$pkgver"
  go test ./...
}

package() {
  cd "$_realname-$pkgver"
  install -Dm755 build/$_realname "$pkgdir$MINGW_PREFIX/bin/$_realname"
  install -Dm644 LICENSE "$pkgdir$MINGW_PREFIX/share/licenses/$_realname/LICENSE"
}

=== packages/aur/PKGBUILD ===
# Maintainer: Ben Boyter <ben@boyter.org>
pkgname=scc
pkgver=2.10.1
pkgrel=1
pkgdesc="Sloc, Cloc and Code: scc is a very fast accurate code counter with complexity calculations and COCOMO estimates written in pure Go"
arch=('x86_64' 'i386')
url="https://github.com/boyter/scc"
license=('MIT')
source=(https://github.com/boyter/scc/releases/download/v$pkgver/scc-$pkgver-$arch-unknown-linux.zip)
sha256sums=('663da4a750fd4f0f3d9328dd58f6850c46f458f94258c04b78b630e47d667ff8')

package() {
          mkdir -p $pkgdir/usr/bin
          cp $srcdir/scc $pkgdir/usr/bin
}
